//sortie PWM sur OCR2A D11 CH2 et OCR2B D3 CH1
//Fech sur D2

ISR (TIMER0_COMPA_vect) {
  PORTD |= 4;  
  OCR2A = ADCH;
  PORTD &= ~4;
  TCNT1 = 0;
}

int main(void)
{

  Serial.begin(115200);
  DDRD = 254;
  DDRB = 255;

  cli();
  TCCR0A = (1 << WGM01); //CTC mode
  TCCR0B = (1 << CS01) | (1 << CS00); // FREQ 16Mhz/64 = 250 000

  //5Khz= 16Mhz/(64 * (OCR0A +1))   ORC0A= (16Mhz / (64 * 5Khz)) -1  =49
  //10Khz= 16Mhz/(64 * (OCR0A +1))  ORC0A= (16Mhz / (64 * 10Khz)) -1  =24

  //OCR0A = 49;
  //OCR0A = 24;
  OCR0A = 12;
  TIMSK0 = (1 << OCIE0A); //irq



  TCCR2A = 0xA3; //timer 0 fast PWm at PD5/6
  TCCR2B = 0x01; //16Mhz
  OCR2A = 128;

  ADMUX   = 0x40 ;                    // channel0, ref to internal input (vcc)
  ADMUX  |= (1 << ADLAR) ;            // left-justified (only need 8 bits)
  ADCSRA  = (1 << ADPS2) ;            // pre-scale 16
  ADCSRA |= (1 << ADATE) ;            // auto-trigger (free-run)
  ADCSRB  = 0x00 ;                    // free-running
  DIDR0  |= (1 << ADC0D) ;            // disable digital driver on ADC0
  ADCSRA |= (1 << ADEN) ;             // enable ADC
  ADCSRA |= (1 << ADSC) ;             // trigger first conversion

  sei();
  while (true) {
  }
}
